"use strict";

exports.__esModule = true;
exports["default"] = createQueryCacheId;

var _querystring = _interopRequireDefault(require("querystring"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function createQueryCacheId(uri, options) {
  var str = (options && options.method ? options.method : 'GET') + ":" + uri;
  var body;

  if (options) {
    if (options.body) {
      if (options.body instanceof FormData) {
        body = {};
        options.body.forEach(function (value, k) {
          body[k] = value;
        });
      } else {
        body = options.body;
      }

      var bodyStr = _querystring["default"].stringify(body);

      if (bodyStr) {
        str += "@BODY:" + bodyStr;
      }
    }
  }

  return str;
}