export interface FetchConnectorState {
    [key: string]: {
        error?: Error;
        payload?: any;
        promise?: Promise<any>;
    };
}
export interface FetchConnectorCache {
    stack: string[];
    state: FetchConnectorState;
}
export interface FetchConnector {
    requestHeaders?: object;
    cache: FetchConnectorCache;
}
interface FetchConnectorOptions {
    requestHeaders?: object;
    initialState?: FetchConnectorCache;
}
export declare const createFetchConnector: ({ requestHeaders, initialState, }?: FetchConnectorOptions) => FetchConnector;
export declare function registerItemToFetchConnector<Payload>(connector: FetchConnector, queryId: string, uri: string, options?: RequestInit): Promise<Payload> | undefined;
export declare function uncacheQueries<Payload>(connector: FetchConnector, queriesIds: string[]): void;
export {};
